import xmlrpc.client
import ssl


class N4dManager:

	def __init__(self):
		
		try:
			self.get_service_variables()
		except:
			self.printa_server="localhost"
			self.variables_server="localhost"
			
		self.read_key()
		
	#def __init__

	
	def read_key(self):
		
		try:
			f=open("/etc/n4d/key")
			self.key=f.readline().strip("\n")
			f.close()
		except:
			self.key=None
			
	#def read_key


	def get_service_variables(self):
		
		client=xmlrpc.client.ServerProxy("https://localhost:9779",allow_none=True,context=ssl._create_unverified_context())
		
		vars=client.get_variables("","VariablesManager",["PRINTACLIENTCONFIG","REMOTE_VARIABLES_SERVER"])
		self.printa_server="localhost"
		self.variables_server="localhost"
		
		if vars["REMOTE_VARIABLES_SERVER"]!=None:
			self.variables_server=vars["REMOTE_VARIABLES_SERVER"]
			
		if vars["PRINTACLIENTCONFIG"]!=None:
			self.printa_server=vars["PRINTACLIENTCONFIG"]["server"]
		
	#def get_variables
	
	
	def cancel_job(self,job):
		try:
			client=xmlrpc.client.ServerProxy("https://localhost:9779",allow_none=True,context=ssl._create_unverified_context())
			return client.remove_job(self.key,"Printa",job)
		except Exception as e:
			return e
		
	#def cancel_job

	
	def add_request(self,ip,user,msg):
		client=xmlrpc.client.ServerProxy("https://localhost:9779",allow_none=True,context=ssl._create_unverified_context())
		ret=client.add_request(self.key,"PrintaServer",ip,user,msg)
	
		return ret
		
	#def register_request

	
	def remove_request(self,id):
	
		client=xmlrpc.client.ServerProxy("https://localhost:9779",allow_none=True,context=ssl._create_unverified_context())
		ret=client.remove_request(self.key,"PrintaServer",id)
	
		return ret
		
	#def remove_request
	
		
	def check_if_printable(self,id):
		
		# [status,int_value]
		# -2 locked
		# 0 OK
		# -3 not enough quota
		client=xmlrpc.client.ServerProxy("https://%s:9779"%self.variables_server,allow_none=True,context=ssl._create_unverified_context())
		return client.check_if_printable(self.key,"PrintaServer",id)
			
	#def check_if_printable
	
	
	def substract_user_quota(self,user,value):
		
		client=xmlrpc.client.ServerProxy("https://%s:9779"%self.variables_server,allow_none=True,context=ssl._create_unverified_context())
		return client.substract_user_quota(self.key,"PrintaServer",user,value)
		
	#def substract_user_quota
	

	def get_user_history(self,user):
		
		client=xmlrpc.client.ServerProxy("https://%s:9779"%self.variables_server,allow_none=True,context=ssl._create_unverified_context())
		return client.get_user_history(self.key,"PrintaServer",user)
		
	#def get_user_history
	
	
	def is_job_in_user_history(self,user,job):
		
		jobs_history=self.get_user_history(user)
		
		for job_id in jobs_history:
			
			if job_id==job["id"]:
				return (True,jobs_history[job_id])
				
		return (False,None)
		
	#def is_job_in_user_history
	
	
#class N4dManager